<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
WARNING: This is a system configuration file, please DO NOT EDIT this file directly!
... Instead, use the plugin options panel in WordPress® to override these settings.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit;
/*
Detect if this is WordPress® with Multisite/Networking.
*/
if (($GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["is_multisite"] = ((function_exists ("is_multisite") && is_multisite ()) || function_exists ("wpmu_current_site")))/**/
&& ((defined ("MULTISITE_FARM") && MULTISITE_FARM) || file_exists (dirname (dirname (__FILE__)) . "/multisite.farm"))) /* For Multisite Blog Farms. */
	$GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["is_multisite_farm"] = true;
/*
Determine the full url to the directory this plugin resides in.
*/
$GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["dir_url"] = WP_CONTENT_URL . /* URL to the plugin directory. */
preg_replace ("/^(.*?)(\/" . preg_quote (basename (WP_CONTENT_DIR), "/") . ")/", "", dirname (dirname (__FILE__)));
/*
Check if the plugin has been configured *should be set after the first config via options panel*.
*/
$GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["configured"] = get_option ("ws_plugin__super_news_configured");
/*
Configure the right menu options panel for this software.
*/
$GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["menu-r"] = array ("tools" => true, "support" => true, "donations" => true);
/*
Configure the file modification time for the syscon.inc.php file.
*/
$GLOBALS["WS_PLUGIN__"]["super_news"]["c"]["filemtime"] = filemtime (__FILE__);
/*
Configure & validate all of the plugin options; and set their defaults.
*/
function ws_plugin__super_news_configure_options_and_their_defaults ($options = FALSE) /* Can also be used to merge options with defaults. */
	{
		/* Here we build the default options array, which will be merged with the user options.
		It is important to note that sometimes default options may not or should not be pre-filled on an options form.
		These defaults are for the system to use in various ways, we may choose not to pre-fill certain fields.
		In other words, some defaults may be used internally, but to the user, the option will be empty. */
		$default_options = array ( /* Please comment each line for clarity, it is easy to forget things. */
		/**/
		"options_version" => "1.0", /* Used internally to keep runtime files up-to-date. */
		/**/
		"run_deactivation_routines" => "1", /* Should deactivation routines be processed? */
		/**/
		"google_key" => "", /* The Google Ajax Search API Key for this domain. */
		"thumb_key" => "", /* A Key to one of the integrated thumbnail services. */
		"thumb_provider" => "", /* (shrinktheweb|websnapr|thumbshots) or empty. */
		/**/
		"custom_injection" => "", /* Custom code that will be injected into results. */
		/**/
		"enqueue_styles" => "1"); /* Whether we should load the default styles. */
		/*
		Here they are merged. User options will overwrite some or all default values. 
		*/
		$GLOBALS["WS_PLUGIN__"]["super_news"]["o"] = array_merge ($default_options, (($options !== false) ? (array)$options : (array)get_option ("ws_plugin__super_news_options")));
		/*
		Validate each option, possibly reverting back to the default value if invalid.
		Also check if options were passed in on some of these, in case empty values are to be allowed. 
		*/
		foreach ($GLOBALS["WS_PLUGIN__"]["super_news"]["o"] as $key => &$value)
			{
				if (!is_array ($value))
					$value = trim (stripslashes ($value));
				else /* A string, or an array of strings. */
					foreach ($value as $k => $v)
						$value[$k] = trim (stripslashes ($v));
				/**/
				if (!isset ($default_options[$key]))
					unset ($GLOBALS["WS_PLUGIN__"]["super_news"]["o"][$key]);
				/**/
				else if ($key === "options_version" && (!is_string ($value) || !is_numeric ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "run_deactivation_routines" && (!is_string ($value) || !is_numeric ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "google_key" && (!is_string ($value) || !strlen ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "thumb_key" && (!is_string ($value) || !strlen ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "thumb_provider" && (!is_string ($value) || !strlen ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "custom_injection" && (!is_string ($value) || !strlen ($value)))
					$value = $default_options[$key];
				/**/
				else if ($key === "enqueue_styles" && (!is_string ($value) || !is_numeric ($value)))
					$value = $default_options[$key];
			}
		/**/
		return $GLOBALS["WS_PLUGIN__"]["super_news"]["o"];
	}
/*
Now lets call the function.
*/
call_user_func ("ws_plugin__super_news_configure_options_and_their_defaults");
?>